% UKR Toolbox  Version 2b
%
% (C) Stefan Klanke, Roland Memisevic (early parts)
% Please send bug reports to sk@sklanke.de
%
% Setup scripts 
%
%   ukr_buildmex  - Build mex replacements for some functions
%                   You do not have to run this script, but you
%                   should if performance is of concern
%
% Demo
%
%   ukr_demo      - Simple demo to present and explain basic UKR Toolbox features.
% 
% Standard functions:
%
%   ukr_model     - Create a valid (but untrained) ukr model structure. 
%
%   ukr_train     - Train a valid ukr model. 
%
%   ukr_f         - Evaluate regression function. ( Standard UKR)
%
%   ukr_g         - Evaluate backward mapping for one or several 
%                   dataspace elements.
%
%   ukr_b         - Compute matrix of basis function responses for latent
%                   dataset X (in columns)
%
%   ukr_proj      - Compute orthogonal projection onto ukr manifold.
%                   Just a combination of ukr_g and ukr_f.
%
%   ukr_mse       - Compute mean squared reconstruction error that 
%                   results from projecting a given dataset onto a 
%                   UKR manifold.
%
%   ukr_nr        - Determine nearest reconstruction for one more 
%                   observable space elements (Standard UKR)
%
%   ukr_nfr       - Determine index of nearest reconstruction in feature
%                   space (Kernel UKR)
%
%   ukr_density   - Estimate density in latent space (given trained model)
%
% Auxiliary functions:
%
%   ukr_opt       - optimization routine based on the RPROP scheme 
%
%   ukr_g_opt     - optimization routine used in ukr_g.  Applies a
%                   specialized feasible trust-region SQP algorithm.
%
%   ukr_errgrad   - ukr error function and gradient used for training 
%                   a standard ukr model.
%
%   ukr_denscon   - ukr density constraint function (training)
%
%   ukr_g_errgradhess, ukg_g_congrad
%                 - projection error, gradient and approximate hessian
%	                 resp. density constraint and its gradient
%		              used for backward mapping (in ukr_g)
%
%   ukr_eta       - Determine suitable density constraint eta for a 
%                   given UKR model.
%
%   ukr_mercer    - Builds data structure needed for projection data
%                   onto feature space UKR models
%
%   ukr_pca       - calculates PCA (or KPCA) initialization
%
