#ifndef __SPECIALMATH_H
#define __SPECIALMATH_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

double sqDist(const double *a,const double *b,int n);
void calcSqDistances(double *d,const double *X,const double *x,int q,int N);

void shiftXcalcDists(double *d,double *Xs,const double *X,const double *x,int q,int N);

void scaleVector(double alpha,double *v,int n);
double vectorSum1(const double *V,int n);
double vectorSum2(const double *V,int n);

void calcSquareSums(double *sums,const double *A,int m,int n);

void storeAlphaUtoV(double alpha,const double *U,double *V,int n);
void addAlphaUtoV(double alpha,const double *U,double *V,int n);
double dotProduct(const double *U,const double *V,int n);

void addSparseToFull(const int *table,const double *s,double *f,int n);

/* y=Ax or y=A'x : A is m x n matrix */
void multMatrixVector(double *y,const double *A,const double *x,int m,int n);
void multMatrixVectorSp(double *y,const double *A,const double *x,int m,int nz, const int *ir);
void multMatrixTVector(double *y,const double *A,const double *x,int m,int n);

/* sA = diag(s) * A : A is a q x N matrix, can be called with sA==A */
void multDiagMatrix(double *sA, const double *s,const double *A,int q,int N);

int invertSymmetricMatrix(double *A, int n);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
