#include "specialmath.h"
#include <mex.h>

void mexFunction(int nlhs, mxArray *plhs[], int nrhs,const mxArray *prhs[]) {
const double *A;
double *invA;
int m,n;

   if (nrhs<1) mexErrMsgTxt("Not enough arguments.");
   
   A = mxGetPr(prhs[0]);
   m = mxGetM(prhs[0]);
   n = mxGetN(prhs[0]);
   
   if (m!=n) mexErrMsgTxt("Argument must be a symmetric matrix.");
   
   plhs[0]=mxCreateDoubleMatrix(n,n,mxREAL);
   invA=mxGetPr(plhs[0]);
   for (m=0;m<n*n;m++) invA[m]=A[m];
   m=invertSymmetricMatrix(invA,n);
   printf("Return value: %i\n",m);
}

