#include <mex.h>
#include <matrix.h>
#include <math.h>
#include "specialmath.h"


void mexFunction(int nlhs, mxArray *plhs[], int nrhs,const mxArray *prhs[]) {
int i,j,m,n,q;
const double *A,*B;
double *D;

   A=mxGetPr(prhs[0]);
   q=mxGetM(prhs[0]);
   m=mxGetN(prhs[0]);
   
   if (nrhs>=2) {
      B=mxGetPr(prhs[1]);
      if (q!=mxGetM(prhs[1])) mexErrMsgTxt("Dimensions do not match.");
   
      n=mxGetN(prhs[1]);
   
      plhs[0]=mxCreateDoubleMatrix(m,n,mxREAL);
      D=mxGetPr(plhs[0]);
   
      for (j=0;j<n;j++) {
         for (i=0;i<m;i++) {
            *D++=sqDist(A+i*q,B+j*q,q);
         }
      }
   } else {
      double *Dfix;
      n=m;
      plhs[0]=mxCreateDoubleMatrix(m,n,mxREAL);
      Dfix=D=mxGetPr(plhs[0]);
   
      for (j=0;j<n;j++) {
         for (i=0;i<j;i++) {
            *D++=Dfix[i*m+j];
         }
         for (i=j;i<m;i++) {
            *D++=sqDist(A+i*q,A+j*q,q);
         }
      }
   }
}
 
