#include <mex.h>
#include <matrix.h>
#include <math.h>
#include "specialmath.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs,const mxArray *prhs[]) {
   const double *A,*B,*b;
   double *ind;
   int d,n,N,i;
   
   if (nrhs!=2) mexErrMsgTxt("Must supply 2 arguments.");
   
   A=mxGetPr(prhs[0]);
   n=mxGetN(prhs[0]);
   d=mxGetM(prhs[0]);
   
   B=mxGetPr(prhs[1]);
   N=mxGetN(prhs[1]);
   if (d!=mxGetM(prhs[1])) mexErrMsgTxt("Dimensions do not match.");
   
   plhs[0]=mxCreateDoubleMatrix(1,n,mxREAL);
   ind=mxGetPr(plhs[0]);
   
   for (i=0;i<n;i++) {
      double mdist;
      int j,mind=0;

      b=B;
      mdist=sqDist(A,b,d);
      for (j=1;j<N;j++) {
         double dist;
         
         b+=d;
         dist=sqDist(A,b,d);
         if (dist<mdist) {
            mdist=dist;
            mind=j;
         }
      }
      A+=d;
      ind[i]=mind+1;
   }
}
