#include "ukr_matlab.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs,const mxArray *prhs[]) {
UKR_Model model;
UKR_Workspace W;
const double *x;
double *f;
int n;

   if (nrhs<2) mexErrMsgTxt("Not enough arguments.");
   if (nrhs>2) mexErrMsgTxt("Too many arguments.");
   
   model = ukr_model_from_matlab(prhs[1]);

   if (model.X==NULL) mexErrMsgTxt("Model does not contain 'X'");
   if (model.Y==NULL) mexErrMsgTxt("Model does not contain 'Y'");
   
   x=mxGetPr(prhs[0]);
   
   if (model.q!=mxGetM(prhs[0])) mexErrMsgTxt("Dimensionality of x does not match model.");
   n=mxGetN(prhs[0]);
   
   plhs[0]=mxCreateDoubleMatrix(model.d,n,mxREAL);
   f=mxGetPr(plhs[0]);
   
   ukr_aux_alloc_workspace(model,&W);
   
   if (nlhs>1) {
      int i;
      
      double *dens;
      
      plhs[1]=mxCreateDoubleMatrix(1,n,mxREAL);
      dens=mxGetPr(plhs[1]);
      
      for (i=0;i<n;i++) {
         dens[i] = ukr_f(f,x,model,&W);
         f+=model.d;
         x+=model.q;
      }
   } else {
      int i;
      for (i=0;i<n;i++) {
         ukr_f(f,x,model,&W);
         f+=model.d;
         x+=model.q;
      }
   }
   ukr_aux_free_workspace(W);
}

