#include "ukr_matlab.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs,const mxArray *prhs[]) {
UKR_Model model;
UKR_Workspace W;
const double *x;

   if (nrhs<2) mexErrMsgTxt("Not enough arguments.");
   if (nrhs>2) mexErrMsgTxt("Too many arguments.");
   
   model = ukr_model_from_matlab(prhs[1]);

   if (model.X==NULL) mexErrMsgTxt("Model does not contain 'X'");
   if (model.Y==NULL) mexErrMsgTxt("Model does not contain 'Y'");
   
   x = ukr_mx_get_matrix(prhs[0], model.q, 1);
   
   if (x==NULL) mexErrMsgTxt("First parameter must be a qx1 column vector.");
   
   plhs[0]=mxCreateDoubleMatrix(model.d,1,mxREAL);
   
   ukr_aux_alloc_workspace(model,&W);
   
   if (nlhs>1) {
      plhs[1]=mxCreateDoubleMatrix(model.d,model.q,mxREAL);
      ukr_fJ(mxGetPr(plhs[0]),mxGetPr(plhs[1]),x,model,&W);
   } else {
      ukr_f(mxGetPr(plhs[0]),x,model,&W);   
   }
   ukr_aux_free_workspace(W);   
  
}

