function eps = ukr_aux_eps(model,level)
% function eps = ukr_aux_eps(model,level)
%
% This function calculates the Epsilon-values (variant 1) for
% smoothing a readily trained (LOO-CV) manifold
%
% This is normally used from within ukr_smooth
%
%  model - trained (possibly unsmooth) UKR model
%  level - lower bound for Epsilon
%

[d,N]=size(model.Y);

eps = abs(model.Y-ukr_f(model.X,model));

if length(level)==1
   eps(eps<level)=level;
elseif isequal(size(level),[d 1])
   LEV = repmat(level,1,N);
   eps(eps<LEV)=LEV(eps<LEV);
else
   error 'Dimension of \"level\" must either be 1x1 or dx1'
end
