function eps = ukr_aux_eps2(model,level)
% function eps = ukr_aux_eps2(model,level)
%
% This function calculates the Epsilon-values (variant 2) for
% smoothing a readily trained (LOO-CV) manifold
%
% This is normally used from within ukr_smooth
%
%  model - trained (possibly unsmooth) UKR model
%  level - lower bound for Epsilon
%

eps = sqrt(sum((model.Y-ukr_f(model.X,model)).^2));
eps(eps<level)=level;
