function [b,J] = ukr_aux_lq_bJ(x,model,K,P) 
%function [b,J] = ukr_aux_lq_bJ(x,model,K,P) 

[q,N] = size(model.X);

Xx = model.X - repmat(x,1,N);   

switch model.degree
   case 1
      n = q+1;

      Xi = [ones(1,N) ; Xx ];
         
      KXiT = repmat(K,1,n).*Xi';
      Gamma = inv(Xi*KXiT);
      
      Ut = Xi'*Gamma;
      PXxU_KG = Xx'.*repmat(P.*Ut(:,1),1,q) - K*Gamma(1,2:q+1);
      
      H = Ut.*repmat(K,1,n);
      b = H(:,1);
                  
      MuM = Xi*(PXxU_KG);
                  
      J = PXxU_KG + H(:,2:q+1)*sum(H(:,1)) - H*MuM;
      
      % J_approx = H(:,2:q+1);
      
   case 2
      n = 2*q +1;
      Xi = [ones(1,N) ; Xx ; Xx.^2 ];
         
      KXiT = repmat(K,1,n).*Xi';
      Gamma = inv(Xi*KXiT);
      
      Ut = Xi'*Gamma;
      PXxU_KG = Xx'.*repmat(P.*Ut(:,1),1,q) ...
         - K*Gamma(1,2:q+1) ...
         - 2*Xi(2:q+1,:)'.*(K*Gamma(1,q+2:n));

      H = Ut.*repmat(K,1,n);
      b = H(:,1);
            
      MuM = Xi*(PXxU_KG);
                  
      J = PXxU_KG + H(:,2:q+1)*sum(H(:,1)) - H*MuM;

   case 3
      if q~=2
         error 'If model.degree==2, model.q must be =2.';
      end
      Xi = [ones(1,N) ; Xx ; Xx.^2; Xx(1,:).*Xx(2,:) ];
      
      KXiT = repmat(K,1,6).*Xi';
      Gamma = inv(Xi*KXiT);
      
      Ut = Xi'*Gamma;
      PXxU_KG = Xx'.*repmat(P.*Ut(:,1),1,2)...
          - K*Gamma(1,2:3) ...
          - 2*Xi(2:3,:)'.*(K*Gamma(1,4:5)) ...
          - 2*Xi([3 2],:)'.*repmat(K*Gamma(1,6),1,2);

      H = Ut.*repmat(K,1,6);
      b = H(:,1);
            
      MuM = Xi*(PXxU_KG);
                  
      J = PXxU_KG + H(:,2:3)*sum(H(:,1)) - H*MuM;
      
   otherwise
      error 'model.degree must be 1,2 (any model.q)  or 3 (model.q=2)';
end
      
      
