function [c, ceq] = ukr_denscon(X, model, varargin)
% function [c, ceq] = ukr_denscon(X, model, varargin)
%
% Calculates N nonlinear constraints (density threshold)
% Normally, you won't use this directly. The second output
% argument is for compatibility with fmincon

error(nargchk(2, 3, nargin))

if (nargin<3)
   eta=model.eta;
else
   eta=varargin{1};
end

% get dimensions:
[q N] = size(X);

% Compute matrix of basis function responses:
[K,sumK] = ukr_kp_dists(ukr_aux_distances(X),model);

% compute constraints:
c = eta - sumK/N;
ceq = [];

