function [dens] = ukr_density(X, model)
% ukr_density : Compute density estimation for one or several latent space elements.
% [dens] = ukr_density(X, model)
%
% Inputs:
%   X       -  Matrix of latent space elements (column-wise).
%   model   -  Valid ukr_model structure.
%
% Output:
%   dens    -  Matrix of normalized basis function responses (column-wise).

error(nargchk(2, 2, nargin))

[dummy, dens]=ukr_kp_dists(ukr_aux_distances(model.X,X),model);

dens = dens/size(model.X,2);
