function [eta] = ukr_eta(model);
% eta=ukr_eta(model)
%
% Auxiliary function used to determine suitable density 
% constraint eta for input ukr model.
%
% Inputs: 
%   model  -  Valid ukr_model structure.
%
% Output: 
%   eta    -  For input ukr model a suitable density constraint eta,
%             defined as the smallest value which ensures 
%             that at least each data space element of the 
%             ukr model belongs to the ukr manifold.

error(nargchk(1, 1, nargin)) 

% get matrix of basis function responses:
eta = min(ukr_density(model.X,model));
