function [X,f,numB] = ukr_opt_boxcon(Xinit, maxiter, model, lb, ub, varargin)
%function [X,f,numB] = ukr_opt_boxcon(Xinit, maxiter, model, lb, ub, varargin)

X=Xinit;
gradBound2=length(X)*(10^-12);

rs = ukr_rprop_init(X);

[q,N]=size(X);

LB = repmat(lb,1,N);
UB = repmat(ub,1,N);


disp=0;
if isfield(model,'display')
   disp=model.display;
end

for iter=0:maxiter

   indL = find(X<=LB);
   indU = find(X>=UB);
   X(indL) = LB(indL);
   X(indU) = UB(indU);

   [f,g]=ukr_errgrad(X,model,varargin{:});
   
   if q==1
      indB = [indL(find(g(indL)>0)) , indU(find(g(indU)<0))];
   else
      indB = [indL(find(g(indL)>0)) ; indU(find(g(indU)<0))];
   end
   g(indB)=0;
   numB = length(indB);

   abs2g=sum(sum(g.^2));
   
   if disp
      fprintf(1,'[%3i] %f ( %i )\n',iter,f, numB);
   end

   if abs2g<=gradBound2 | iter == maxiter
      return
   end
   
   [X, rs]=ukr_rprop_adapt(X, rs, g);   
end
