function [X,f,numB] = ukr_opt_spherecon(Xinit, maxiter, model, R, varargin)
%function [X,f,numB] = ukr_opt_spherecon(Xinit, maxiter, model, R, varargin)

X=Xinit;
gradBound2=length(X)*(10^-12);

rs = ukr_rprop_init(X);

[q,N]=size(X);

R2 = R^2;

disp=0;
if isfield(model,'display')
   disp=model.display;
end

for iter=0:maxiter

   X2 = sum(X.^2,1);
   ind = find(X2>=R2);
   fak = R*X2(ind).^(-0.5);
   
   X(:,ind) = X(:,ind).*repmat(fak,q,1);
   
   if iter>0 & norm(oldX-X,'fro')<1e-6*q*N
      break;
   end

   [f,g]=ukr_errgrad(X,model,varargin{:});
   
   dps = sum(g(:,ind).*X(:,ind),1);
   
   indB = find(dps<0);
   numB = length(indB);
   
   abs2gbf=sum(sum(g.^2));
   
   if numB>0
      dg = X(:,ind(indB)).*repmat(dps(indB)/R2,q,1);
      g(:,ind(indB)) = g(:,ind(indB)) - dg;
   end

   abs2g=sum(sum(g.^2));
   
   if disp
      fprintf(1,'[%3i] %f ( %i )   %f  %f\n',iter,f, numB,abs2g,abs2gbf);
   end

   if abs2g<=gradBound2 | iter == maxiter
      return
   end
   
   oldX = X;
   
   [X, rs]=ukr_rprop_adapt(X, rs, g);   
end
