function [X,F] = ukr_opt_unc_penalty(fungrad,pengrad,lambda,Xinit,maxiter,model,varargin)

disp = 0;
if isfield(model,'display')
   disp = model.display;
end

X=Xinit;
gradBound2=(10^-12)*length(X);

rs = ukr_rprop_init(X);

[f,g]=feval(fungrad,X,model,varargin{:});
[pf,pg]=feval(pengrad,X,model);
pf = pf * lambda;
F = f + pf;      
g = g + lambda*pg;

abs2g=sum(sum(g.^2));
found=abs2g<gradBound2;

iter=0;
while (~found)&(iter<=maxiter)
  
   if disp
      fprintf(1,'[%4i] %f  (%f + %f)\n',iter,F,f,pf);
   end
   
   [X, rs]=ukr_rprop_adapt(X, rs, g);
   
   oldF=F;
   
   [f,g]=feval(fungrad,X,model,varargin{:});
   [pf,pg]=feval(pengrad,X,model);
   pf = pf * lambda;
   F = f + pf;      
   g = g + lambda*pg;
   
   if isnan(F)
     warning('Objective function and/or penalty returned NaN');
     X=rs.oldX;
     F=oldF;
     return;
   end
   
   abs2g=sum(sum(g.^2));

   found=abs2g<gradBound2;
   iter=iter+1;
end
